// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "DistributionCosine.pypp.h"

namespace bp = boost::python;

struct DistributionCosine_wrapper : DistributionCosine, bp::wrapper< DistributionCosine > {

    DistributionCosine_wrapper(DistributionCosine const & arg )
    : DistributionCosine( arg )
      , bp::wrapper< DistributionCosine >(){
        // copy constructor
        m_pyobj = 0;
    }

    DistributionCosine_wrapper( )
    : DistributionCosine( )
      , bp::wrapper< DistributionCosine >(){
        // null constructor
    m_pyobj = 0;
    }

    DistributionCosine_wrapper(double mean, double sigma )
    : DistributionCosine( mean, sigma )
      , bp::wrapper< DistributionCosine >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::DistributionCosine * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->DistributionCosine::clone(  );
        }
    }
    
    ::DistributionCosine * default_clone(  ) const  {
        return DistributionCosine::clone( );
    }

    virtual ::std::vector< double > generateValueList( ::std::size_t nbr_samples, double sigma_factor, ::AttLimits const & limits=::AttLimits( ) ) const  {
        if( bp::override func_generateValueList = this->get_override( "generateValueList" ) )
            return func_generateValueList( nbr_samples, sigma_factor, boost::ref(limits) );
        else{
            return this->DistributionCosine::generateValueList( nbr_samples, sigma_factor, boost::ref(limits) );
        }
    }
    
    ::std::vector< double > default_generateValueList( ::std::size_t nbr_samples, double sigma_factor, ::AttLimits const & limits=::AttLimits( ) ) const  {
        return DistributionCosine::generateValueList( nbr_samples, sigma_factor, boost::ref(limits) );
    }

    virtual double getMean(  ) const  {
        if( bp::override func_getMean = this->get_override( "getMean" ) )
            return func_getMean(  );
        else{
            return this->DistributionCosine::getMean(  );
        }
    }
    
    double default_getMean(  ) const  {
        return DistributionCosine::getMean( );
    }

    virtual double probabilityDensity( double x ) const  {
        if( bp::override func_probabilityDensity = this->get_override( "probabilityDensity" ) )
            return func_probabilityDensity( x );
        else{
            return this->DistributionCosine::probabilityDensity( x );
        }
    }
    
    double default_probabilityDensity( double x ) const  {
        return DistributionCosine::probabilityDensity( x );
    }

    virtual ::std::vector< double > generateValues( ::std::size_t nbr_samples, double xmin, double xmax ) const  {
        if( bp::override func_generateValues = this->get_override( "generateValues" ) )
            return func_generateValues( nbr_samples, xmin, xmax );
        else{
            return this->IDistribution1D::generateValues( nbr_samples, xmin, xmax );
        }
    }
    
    ::std::vector< double > default_generateValues( ::std::size_t nbr_samples, double xmin, double xmax ) const  {
        return IDistribution1D::generateValues( nbr_samples, xmin, xmax );
    }

    PyObject* m_pyobj;

};

void register_DistributionCosine_class(){

    { //::DistributionCosine
        typedef bp::class_< DistributionCosine_wrapper, bp::bases< IDistribution1D >, std::auto_ptr< DistributionCosine_wrapper > > DistributionCosine_exposer_t;
        DistributionCosine_exposer_t DistributionCosine_exposer = DistributionCosine_exposer_t( "DistributionCosine", "Cosine distributio.", bp::init< >() );
        bp::scope DistributionCosine_scope( DistributionCosine_exposer );
        DistributionCosine_exposer.def( bp::init< double, double >(( bp::arg("mean"), bp::arg("sigma") )) );
        { //::DistributionCosine::clone
        
            typedef ::DistributionCosine * ( ::DistributionCosine::*clone_function_type)(  ) const;
            typedef ::DistributionCosine * ( DistributionCosine_wrapper::*default_clone_function_type)(  ) const;
            
            DistributionCosine_exposer.def( 
                "clone"
                , clone_function_type(&::DistributionCosine::clone)
                , default_clone_function_type(&DistributionCosine_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::DistributionCosine::generateValueList
        
            typedef ::std::vector< double > ( ::DistributionCosine::*generateValueList_function_type)( ::std::size_t,double,::AttLimits const & ) const;
            typedef ::std::vector< double > ( DistributionCosine_wrapper::*default_generateValueList_function_type)( ::std::size_t,double,::AttLimits const & ) const;
            
            DistributionCosine_exposer.def( 
                "generateValueList"
                , generateValueList_function_type(&::DistributionCosine::generateValueList)
                , default_generateValueList_function_type(&DistributionCosine_wrapper::default_generateValueList)
                , ( bp::arg("nbr_samples"), bp::arg("sigma_factor"), bp::arg("limits")=::AttLimits( ) ) );
        
        }
        { //::DistributionCosine::getMean
        
            typedef double ( ::DistributionCosine::*getMean_function_type)(  ) const;
            typedef double ( DistributionCosine_wrapper::*default_getMean_function_type)(  ) const;
            
            DistributionCosine_exposer.def( 
                "getMean"
                , getMean_function_type(&::DistributionCosine::getMean)
                , default_getMean_function_type(&DistributionCosine_wrapper::default_getMean) );
        
        }
        { //::DistributionCosine::getSigma
        
            typedef double ( ::DistributionCosine::*getSigma_function_type)(  ) const;
            
            DistributionCosine_exposer.def( 
                "getSigma"
                , getSigma_function_type( &::DistributionCosine::getSigma )
                , "get the sigma parameter of the distribution." );
        
        }
        { //::DistributionCosine::probabilityDensity
        
            typedef double ( ::DistributionCosine::*probabilityDensity_function_type)( double ) const;
            typedef double ( DistributionCosine_wrapper::*default_probabilityDensity_function_type)( double ) const;
            
            DistributionCosine_exposer.def( 
                "probabilityDensity"
                , probabilityDensity_function_type(&::DistributionCosine::probabilityDensity)
                , default_probabilityDensity_function_type(&DistributionCosine_wrapper::default_probabilityDensity)
                , ( bp::arg("x") ) );
        
        }
        { //::IDistribution1D::generateValues
        
            typedef ::std::vector< double > ( ::IDistribution1D::*generateValues_function_type)( ::std::size_t,double,double ) const;
            typedef ::std::vector< double > ( DistributionCosine_wrapper::*default_generateValues_function_type)( ::std::size_t,double,double ) const;
            
            DistributionCosine_exposer.def( 
                "generateValues"
                , generateValues_function_type(&::IDistribution1D::generateValues)
                , default_generateValues_function_type(&DistributionCosine_wrapper::default_generateValues)
                , ( bp::arg("nbr_samples"), bp::arg("xmin"), bp::arg("xmax") ) );
        
        }
    }

}
