// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "Ellipse.pypp.h"

namespace bp = boost::python;

struct Ellipse_wrapper : Geometry::Ellipse, bp::wrapper< Geometry::Ellipse > {

    Ellipse_wrapper(double xcenter, double ycenter, double xradius, double yradius, double theta=0.0 )
    : Geometry::Ellipse( xcenter, ycenter, xradius, yradius, theta )
      , bp::wrapper< Geometry::Ellipse >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::Geometry::Ellipse * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->Geometry::Ellipse::clone(  );
        }
    }
    
    ::Geometry::Ellipse * default_clone(  ) const  {
        return Geometry::Ellipse::clone( );
    }

    virtual bool contains( double x, double y ) const  {
        if( bp::override func_contains = this->get_override( "contains" ) )
            return func_contains( x, y );
        else{
            return this->Geometry::Ellipse::contains( x, y );
        }
    }
    
    bool default_contains( double x, double y ) const  {
        return Geometry::Ellipse::contains( x, y );
    }

    virtual bool contains( ::Bin1D const & binx, ::Bin1D const & biny ) const  {
        if( bp::override func_contains = this->get_override( "contains" ) )
            return func_contains( boost::ref(binx), boost::ref(biny) );
        else{
            return this->Geometry::Ellipse::contains( boost::ref(binx), boost::ref(biny) );
        }
    }
    
    bool default_contains( ::Bin1D const & binx, ::Bin1D const & biny ) const  {
        return Geometry::Ellipse::contains( boost::ref(binx), boost::ref(biny) );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_Ellipse_class(){

    { //::Geometry::Ellipse
        typedef bp::class_< Ellipse_wrapper, bp::bases< Geometry::IShape2D >, std::auto_ptr< Ellipse_wrapper >, boost::noncopyable > Ellipse_exposer_t;
        Ellipse_exposer_t Ellipse_exposer = Ellipse_exposer_t( "Ellipse", "Ellipse shap.", bp::init< double, double, double, double, bp::optional< double > >(( bp::arg("xcenter"), bp::arg("ycenter"), bp::arg("xradius"), bp::arg("yradius"), bp::arg("theta")=0.0 ), "Ellipse constructor @param xcenter x-coordinate of Ellipse's center @param ycenter y-coordinate of Ellipse's center @param xradius Radius along x-axis @param yradius Radius along y-axis @param theta Angle of Ellipse rotation in radians \n\n:Parameters:\n  - 'xcenter' - x-coordinate of Ellipse's center\n  - 'ycenter' - y-coordinate of Ellipse's center\n  - 'xradius' - Radius along x-axis\n  - 'yradius' - Radius along y-axis\n  - 'theta' - Angle of Ellipse rotation in radians\n") );
        bp::scope Ellipse_scope( Ellipse_exposer );
        { //::Geometry::Ellipse::clone
        
            typedef ::Geometry::Ellipse * ( ::Geometry::Ellipse::*clone_function_type)(  ) const;
            typedef ::Geometry::Ellipse * ( Ellipse_wrapper::*default_clone_function_type)(  ) const;
            
            Ellipse_exposer.def( 
                "clone"
                , clone_function_type(&::Geometry::Ellipse::clone)
                , default_clone_function_type(&Ellipse_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::Geometry::Ellipse::contains
        
            typedef bool ( ::Geometry::Ellipse::*contains_function_type)( double,double ) const;
            typedef bool ( Ellipse_wrapper::*default_contains_function_type)( double,double ) const;
            
            Ellipse_exposer.def( 
                "contains"
                , contains_function_type(&::Geometry::Ellipse::contains)
                , default_contains_function_type(&Ellipse_wrapper::default_contains)
                , ( bp::arg("x"), bp::arg("y") ) );
        
        }
        { //::Geometry::Ellipse::contains
        
            typedef bool ( ::Geometry::Ellipse::*contains_function_type)( ::Bin1D const &,::Bin1D const & ) const;
            typedef bool ( Ellipse_wrapper::*default_contains_function_type)( ::Bin1D const &,::Bin1D const & ) const;
            
            Ellipse_exposer.def( 
                "contains"
                , contains_function_type(&::Geometry::Ellipse::contains)
                , default_contains_function_type(&Ellipse_wrapper::default_contains)
                , ( bp::arg("binx"), bp::arg("biny") ) );
        
        }
        { //::Geometry::Ellipse::getCenterX
        
            typedef double ( ::Geometry::Ellipse::*getCenterX_function_type)(  ) const;
            
            Ellipse_exposer.def( 
                "getCenterX"
                , getCenterX_function_type( &::Geometry::Ellipse::getCenterX )
                , "Returns true if area defined by two bins is inside or on border of ellipse. More precisely, if mid point of two bins satisfy this condition. " );
        
        }
        { //::Geometry::Ellipse::getCenterY
        
            typedef double ( ::Geometry::Ellipse::*getCenterY_function_type)(  ) const;
            
            Ellipse_exposer.def( 
                "getCenterY"
                , getCenterY_function_type( &::Geometry::Ellipse::getCenterY ) );
        
        }
        { //::Geometry::Ellipse::getRadiusX
        
            typedef double ( ::Geometry::Ellipse::*getRadiusX_function_type)(  ) const;
            
            Ellipse_exposer.def( 
                "getRadiusX"
                , getRadiusX_function_type( &::Geometry::Ellipse::getRadiusX ) );
        
        }
        { //::Geometry::Ellipse::getRadiusY
        
            typedef double ( ::Geometry::Ellipse::*getRadiusY_function_type)(  ) const;
            
            Ellipse_exposer.def( 
                "getRadiusY"
                , getRadiusY_function_type( &::Geometry::Ellipse::getRadiusY ) );
        
        }
        { //::Geometry::Ellipse::getTheta
        
            typedef double ( ::Geometry::Ellipse::*getTheta_function_type)(  ) const;
            
            Ellipse_exposer.def( 
                "getTheta"
                , getTheta_function_type( &::Geometry::Ellipse::getTheta ) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( Ellipse_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            Ellipse_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&Ellipse_wrapper::default_transferToCPP) );
        
        }
    }

}
