// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FTDecayFunction2DGauss.pypp.h"

namespace bp = boost::python;

struct FTDecayFunction2DGauss_wrapper : FTDecayFunction2DGauss, bp::wrapper< FTDecayFunction2DGauss > {

    FTDecayFunction2DGauss_wrapper(FTDecayFunction2DGauss const & arg )
    : FTDecayFunction2DGauss( arg )
      , bp::wrapper< FTDecayFunction2DGauss >(){
        // copy constructor
        m_pyobj = 0;
    }

    FTDecayFunction2DGauss_wrapper(double decay_length_x, double decay_length_y )
    : FTDecayFunction2DGauss( decay_length_x, decay_length_y )
      , bp::wrapper< FTDecayFunction2DGauss >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FTDecayFunction2DGauss * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FTDecayFunction2DGauss::clone(  );
        }
    }
    
    ::FTDecayFunction2DGauss * default_clone(  ) const  {
        return FTDecayFunction2DGauss::clone( );
    }

    virtual double evaluate( double qx, double qy ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( qx, qy );
        else{
            return this->FTDecayFunction2DGauss::evaluate( qx, qy );
        }
    }
    
    double default_evaluate( double qx, double qy ) const  {
        return FTDecayFunction2DGauss::evaluate( qx, qy );
    }

    PyObject* m_pyobj;

};

void register_FTDecayFunction2DGauss_class(){

    { //::FTDecayFunction2DGauss
        typedef bp::class_< FTDecayFunction2DGauss_wrapper, bp::bases< IFTDecayFunction2D >, std::auto_ptr< FTDecayFunction2DGauss_wrapper > > FTDecayFunction2DGauss_exposer_t;
        FTDecayFunction2DGauss_exposer_t FTDecayFunction2DGauss_exposer = FTDecayFunction2DGauss_exposer_t( "FTDecayFunction2DGauss", "2 dimensional Gauss decay function in reciprocal space.", bp::init< double, double >(( bp::arg("decay_length_x"), bp::arg("decay_length_y") )) );
        bp::scope FTDecayFunction2DGauss_scope( FTDecayFunction2DGauss_exposer );
        { //::FTDecayFunction2DGauss::clone
        
            typedef ::FTDecayFunction2DGauss * ( ::FTDecayFunction2DGauss::*clone_function_type)(  ) const;
            typedef ::FTDecayFunction2DGauss * ( FTDecayFunction2DGauss_wrapper::*default_clone_function_type)(  ) const;
            
            FTDecayFunction2DGauss_exposer.def( 
                "clone"
                , clone_function_type(&::FTDecayFunction2DGauss::clone)
                , default_clone_function_type(&FTDecayFunction2DGauss_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FTDecayFunction2DGauss::evaluate
        
            typedef double ( ::FTDecayFunction2DGauss::*evaluate_function_type)( double,double ) const;
            typedef double ( FTDecayFunction2DGauss_wrapper::*default_evaluate_function_type)( double,double ) const;
            
            FTDecayFunction2DGauss_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::FTDecayFunction2DGauss::evaluate)
                , default_evaluate_function_type(&FTDecayFunction2DGauss_wrapper::default_evaluate)
                , ( bp::arg("qx"), bp::arg("qy") ) );
        
        }
    }

}
