// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FTDistribution1DGate.pypp.h"

namespace bp = boost::python;

struct FTDistribution1DGate_wrapper : FTDistribution1DGate, bp::wrapper< FTDistribution1DGate > {

    FTDistribution1DGate_wrapper(FTDistribution1DGate const & arg )
    : FTDistribution1DGate( arg )
      , bp::wrapper< FTDistribution1DGate >(){
        // copy constructor
        m_pyobj = 0;
    }

    FTDistribution1DGate_wrapper(double omega )
    : FTDistribution1DGate( omega )
      , bp::wrapper< FTDistribution1DGate >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FTDistribution1DGate * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FTDistribution1DGate::clone(  );
        }
    }
    
    ::FTDistribution1DGate * default_clone(  ) const  {
        return FTDistribution1DGate::clone( );
    }

    virtual double evaluate( double q ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( q );
        else{
            return this->FTDistribution1DGate::evaluate( q );
        }
    }
    
    double default_evaluate( double q ) const  {
        return FTDistribution1DGate::evaluate( q );
    }

    PyObject* m_pyobj;

};

void register_FTDistribution1DGate_class(){

    { //::FTDistribution1DGate
        typedef bp::class_< FTDistribution1DGate_wrapper, bp::bases< IFTDistribution1D >, std::auto_ptr< FTDistribution1DGate_wrapper > > FTDistribution1DGate_exposer_t;
        FTDistribution1DGate_exposer_t FTDistribution1DGate_exposer = FTDistribution1DGate_exposer_t( "FTDistribution1DGate", "1 dimensional Gate distribution in Fourier space.", bp::init< double >(( bp::arg("omega") )) );
        bp::scope FTDistribution1DGate_scope( FTDistribution1DGate_exposer );
        { //::FTDistribution1DGate::clone
        
            typedef ::FTDistribution1DGate * ( ::FTDistribution1DGate::*clone_function_type)(  ) const;
            typedef ::FTDistribution1DGate * ( FTDistribution1DGate_wrapper::*default_clone_function_type)(  ) const;
            
            FTDistribution1DGate_exposer.def( 
                "clone"
                , clone_function_type(&::FTDistribution1DGate::clone)
                , default_clone_function_type(&FTDistribution1DGate_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FTDistribution1DGate::evaluate
        
            typedef double ( ::FTDistribution1DGate::*evaluate_function_type)( double ) const;
            typedef double ( FTDistribution1DGate_wrapper::*default_evaluate_function_type)( double ) const;
            
            FTDistribution1DGate_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::FTDistribution1DGate::evaluate)
                , default_evaluate_function_type(&FTDistribution1DGate_wrapper::default_evaluate)
                , ( bp::arg("q") ) );
        
        }
    }

}
