// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FTDistribution1DGauss.pypp.h"

namespace bp = boost::python;

struct FTDistribution1DGauss_wrapper : FTDistribution1DGauss, bp::wrapper< FTDistribution1DGauss > {

    FTDistribution1DGauss_wrapper(FTDistribution1DGauss const & arg )
    : FTDistribution1DGauss( arg )
      , bp::wrapper< FTDistribution1DGauss >(){
        // copy constructor
        m_pyobj = 0;
    }

    FTDistribution1DGauss_wrapper(double omega )
    : FTDistribution1DGauss( omega )
      , bp::wrapper< FTDistribution1DGauss >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FTDistribution1DGauss * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FTDistribution1DGauss::clone(  );
        }
    }
    
    ::FTDistribution1DGauss * default_clone(  ) const  {
        return FTDistribution1DGauss::clone( );
    }

    virtual double evaluate( double q ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( q );
        else{
            return this->FTDistribution1DGauss::evaluate( q );
        }
    }
    
    double default_evaluate( double q ) const  {
        return FTDistribution1DGauss::evaluate( q );
    }

    PyObject* m_pyobj;

};

void register_FTDistribution1DGauss_class(){

    { //::FTDistribution1DGauss
        typedef bp::class_< FTDistribution1DGauss_wrapper, bp::bases< IFTDistribution1D >, std::auto_ptr< FTDistribution1DGauss_wrapper > > FTDistribution1DGauss_exposer_t;
        FTDistribution1DGauss_exposer_t FTDistribution1DGauss_exposer = FTDistribution1DGauss_exposer_t( "FTDistribution1DGauss", "1 dimensional Gauss distribution in Fourier space.", bp::init< double >(( bp::arg("omega") )) );
        bp::scope FTDistribution1DGauss_scope( FTDistribution1DGauss_exposer );
        { //::FTDistribution1DGauss::clone
        
            typedef ::FTDistribution1DGauss * ( ::FTDistribution1DGauss::*clone_function_type)(  ) const;
            typedef ::FTDistribution1DGauss * ( FTDistribution1DGauss_wrapper::*default_clone_function_type)(  ) const;
            
            FTDistribution1DGauss_exposer.def( 
                "clone"
                , clone_function_type(&::FTDistribution1DGauss::clone)
                , default_clone_function_type(&FTDistribution1DGauss_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FTDistribution1DGauss::evaluate
        
            typedef double ( ::FTDistribution1DGauss::*evaluate_function_type)( double ) const;
            typedef double ( FTDistribution1DGauss_wrapper::*default_evaluate_function_type)( double ) const;
            
            FTDistribution1DGauss_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::FTDistribution1DGauss::evaluate)
                , default_evaluate_function_type(&FTDistribution1DGauss_wrapper::default_evaluate)
                , ( bp::arg("q") ) );
        
        }
    }

}
