// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "FTDistribution2DGauss.pypp.h"

namespace bp = boost::python;

struct FTDistribution2DGauss_wrapper : FTDistribution2DGauss, bp::wrapper< FTDistribution2DGauss > {

    FTDistribution2DGauss_wrapper(FTDistribution2DGauss const & arg )
    : FTDistribution2DGauss( arg )
      , bp::wrapper< FTDistribution2DGauss >(){
        // copy constructor
        m_pyobj = 0;
    }

    FTDistribution2DGauss_wrapper(double coherence_length_x, double coherence_length_y )
    : FTDistribution2DGauss( coherence_length_x, coherence_length_y )
      , bp::wrapper< FTDistribution2DGauss >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::FTDistribution2DGauss * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->FTDistribution2DGauss::clone(  );
        }
    }
    
    ::FTDistribution2DGauss * default_clone(  ) const  {
        return FTDistribution2DGauss::clone( );
    }

    virtual double evaluate( double qx, double qy ) const  {
        if( bp::override func_evaluate = this->get_override( "evaluate" ) )
            return func_evaluate( qx, qy );
        else{
            return this->FTDistribution2DGauss::evaluate( qx, qy );
        }
    }
    
    double default_evaluate( double qx, double qy ) const  {
        return FTDistribution2DGauss::evaluate( qx, qy );
    }

    PyObject* m_pyobj;

};

void register_FTDistribution2DGauss_class(){

    { //::FTDistribution2DGauss
        typedef bp::class_< FTDistribution2DGauss_wrapper, bp::bases< IFTDistribution2D >, std::auto_ptr< FTDistribution2DGauss_wrapper > > FTDistribution2DGauss_exposer_t;
        FTDistribution2DGauss_exposer_t FTDistribution2DGauss_exposer = FTDistribution2DGauss_exposer_t( "FTDistribution2DGauss", "2 dimensional Gauss distribution in Fourier space.", bp::init< double, double >(( bp::arg("coherence_length_x"), bp::arg("coherence_length_y") )) );
        bp::scope FTDistribution2DGauss_scope( FTDistribution2DGauss_exposer );
        { //::FTDistribution2DGauss::clone
        
            typedef ::FTDistribution2DGauss * ( ::FTDistribution2DGauss::*clone_function_type)(  ) const;
            typedef ::FTDistribution2DGauss * ( FTDistribution2DGauss_wrapper::*default_clone_function_type)(  ) const;
            
            FTDistribution2DGauss_exposer.def( 
                "clone"
                , clone_function_type(&::FTDistribution2DGauss::clone)
                , default_clone_function_type(&FTDistribution2DGauss_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::FTDistribution2DGauss::evaluate
        
            typedef double ( ::FTDistribution2DGauss::*evaluate_function_type)( double,double ) const;
            typedef double ( FTDistribution2DGauss_wrapper::*default_evaluate_function_type)( double,double ) const;
            
            FTDistribution2DGauss_exposer.def( 
                "evaluate"
                , evaluate_function_type(&::FTDistribution2DGauss::evaluate)
                , default_evaluate_function_type(&FTDistribution2DGauss_wrapper::default_evaluate)
                , ( bp::arg("qx"), bp::arg("qy") ) );
        
        }
    }

}
