// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "IDistribution1D.pypp.h"

namespace bp = boost::python;

struct IDistribution1D_wrapper : IDistribution1D, bp::wrapper< IDistribution1D > {

    IDistribution1D_wrapper( )
    : IDistribution1D( )
      , bp::wrapper< IDistribution1D >(){
        // null constructor
    m_pyobj = 0;
    }

    virtual ::IDistribution1D * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->IDistribution1D::clone(  );
        }
    }
    
    ::IDistribution1D * default_clone(  ) const  {
        return IDistribution1D::clone( );
    }

    virtual ::std::vector< double > generateValueList( ::std::size_t nbr_samples, double sigma_factor, ::AttLimits const & limits=::AttLimits( ) ) const {
        bp::override func_generateValueList = this->get_override( "generateValueList" );
        return func_generateValueList( nbr_samples, sigma_factor, boost::ref(limits) );
    }

    virtual ::std::vector< double > generateValues( ::std::size_t nbr_samples, double xmin, double xmax ) const  {
        if( bp::override func_generateValues = this->get_override( "generateValues" ) )
            return func_generateValues( nbr_samples, xmin, xmax );
        else{
            return this->IDistribution1D::generateValues( nbr_samples, xmin, xmax );
        }
    }
    
    ::std::vector< double > default_generateValues( ::std::size_t nbr_samples, double xmin, double xmax ) const  {
        return IDistribution1D::generateValues( nbr_samples, xmin, xmax );
    }

    virtual double getMean(  ) const {
        bp::override func_getMean = this->get_override( "getMean" );
        return func_getMean(  );
    }

    virtual double probabilityDensity( double x ) const {
        bp::override func_probabilityDensity = this->get_override( "probabilityDensity" );
        return func_probabilityDensity( x );
    }

    PyObject* m_pyobj;

};

void register_IDistribution1D_class(){

    { //::IDistribution1D
        typedef bp::class_< IDistribution1D_wrapper, bp::bases< IParameterized >, std::auto_ptr< IDistribution1D_wrapper >, boost::noncopyable > IDistribution1D_exposer_t;
        IDistribution1D_exposer_t IDistribution1D_exposer = IDistribution1D_exposer_t( "IDistribution1D", "Interface for 1 dimensional distribution.", bp::init< >() );
        bp::scope IDistribution1D_scope( IDistribution1D_exposer );
        { //::IDistribution1D::clone
        
            typedef ::IDistribution1D * ( ::IDistribution1D::*clone_function_type)(  ) const;
            typedef ::IDistribution1D * ( IDistribution1D_wrapper::*default_clone_function_type)(  ) const;
            
            IDistribution1D_exposer.def( 
                "clone"
                , clone_function_type(&::IDistribution1D::clone)
                , default_clone_function_type(&IDistribution1D_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IDistribution1D::generateValueList
        
            typedef ::std::vector<double, std::allocator<double> > ( ::IDistribution1D::*generateValueList_function_type)( ::std::size_t,double,::AttLimits const & ) const;
            
            IDistribution1D_exposer.def( 
                "generateValueList"
                , bp::pure_virtual( generateValueList_function_type(&::IDistribution1D::generateValueList) )
                , ( bp::arg("nbr_samples"), bp::arg("sigma_factor"), bp::arg("limits")=::AttLimits( ) )
                , "generate list of sample values @param nbr_samples number of values to generate @param sigma_factor parameter to derive min,max range for sample values @return vector of generated values \n\n:Parameters:\n  - 'nbr_samples' - number of values to generate\n  - 'sigma_factor' - parameter to derive min,max range for sample values\n" );
        
        }
        { //::IDistribution1D::generateValues
        
            typedef ::std::vector< double > ( ::IDistribution1D::*generateValues_function_type)( ::std::size_t,double,double ) const;
            typedef ::std::vector< double > ( IDistribution1D_wrapper::*default_generateValues_function_type)( ::std::size_t,double,double ) const;
            
            IDistribution1D_exposer.def( 
                "generateValues"
                , generateValues_function_type(&::IDistribution1D::generateValues)
                , default_generateValues_function_type(&IDistribution1D_wrapper::default_generateValues)
                , ( bp::arg("nbr_samples"), bp::arg("xmin"), bp::arg("xmax") ) );
        
        }
        { //::IDistribution1D::getMean
        
            typedef double ( ::IDistribution1D::*getMean_function_type)(  ) const;
            
            IDistribution1D_exposer.def( 
                "getMean"
                , bp::pure_virtual( getMean_function_type(&::IDistribution1D::getMean) )
                , "get the mean of the distribution." );
        
        }
        { //::IDistribution1D::probabilityDensity
        
            typedef double ( ::IDistribution1D::*probabilityDensity_function_type)( double ) const;
            
            IDistribution1D_exposer.def( 
                "probabilityDensity"
                , bp::pure_virtual( probabilityDensity_function_type(&::IDistribution1D::probabilityDensity) )
                , ( bp::arg("x") )
                , "get the probability density for value x." );
        
        }
    }

}
