// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "IFTDecayFunction1D.pypp.h"

namespace bp = boost::python;

struct IFTDecayFunction1D_wrapper : IFTDecayFunction1D, bp::wrapper< IFTDecayFunction1D > {

    IFTDecayFunction1D_wrapper(double omega )
    : IFTDecayFunction1D( omega )
      , bp::wrapper< IFTDecayFunction1D >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::IFTDecayFunction1D * clone(  ) const {
        bp::override func_clone = this->get_override( "clone" );
        return func_clone(  );
    }

    virtual double evaluate( double q ) const {
        bp::override func_evaluate = this->get_override( "evaluate" );
        return func_evaluate( q );
    }

    PyObject* m_pyobj;

};

void register_IFTDecayFunction1D_class(){

    { //::IFTDecayFunction1D
        typedef bp::class_< IFTDecayFunction1D_wrapper, bp::bases< IParameterized >, std::auto_ptr< IFTDecayFunction1D_wrapper >, boost::noncopyable > IFTDecayFunction1D_exposer_t;
        IFTDecayFunction1D_exposer_t IFTDecayFunction1D_exposer = IFTDecayFunction1D_exposer_t( "IFTDecayFunction1D", "Interface for 1 dimensional decay function in reciprocal spac.", bp::init< double >(( bp::arg("omega") )) );
        bp::scope IFTDecayFunction1D_scope( IFTDecayFunction1D_exposer );
        { //::IFTDecayFunction1D::clone
        
            typedef ::IFTDecayFunction1D * ( ::IFTDecayFunction1D::*clone_function_type)(  ) const;
            
            IFTDecayFunction1D_exposer.def( 
                "clone"
                , bp::pure_virtual( clone_function_type(&::IFTDecayFunction1D::clone) )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IFTDecayFunction1D::evaluate
        
            typedef double ( ::IFTDecayFunction1D::*evaluate_function_type)( double ) const;
            
            IFTDecayFunction1D_exposer.def( 
                "evaluate"
                , bp::pure_virtual( evaluate_function_type(&::IFTDecayFunction1D::evaluate) )
                , ( bp::arg("q") ) );
        
        }
        { //::IFTDecayFunction1D::getOmega
        
            typedef double ( ::IFTDecayFunction1D::*getOmega_function_type)(  ) const;
            
            IFTDecayFunction1D_exposer.def( 
                "getOmega"
                , getOmega_function_type( &::IFTDecayFunction1D::getOmega ) );
        
        }
        { //::IFTDecayFunction1D::setOmega
        
            typedef void ( ::IFTDecayFunction1D::*setOmega_function_type)( double ) ;
            
            IFTDecayFunction1D_exposer.def( 
                "setOmega"
                , setOmega_function_type( &::IFTDecayFunction1D::setOmega )
                , ( bp::arg("omega") ) );
        
        }
    }

}
