// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "IInterferenceFunction.pypp.h"

namespace bp = boost::python;

struct IInterferenceFunction_wrapper : IInterferenceFunction, bp::wrapper< IInterferenceFunction > {

    IInterferenceFunction_wrapper()
    : IInterferenceFunction()
      , bp::wrapper< IInterferenceFunction >(){
        // null constructor
        m_pyobj = 0;
    }

    virtual ::IInterferenceFunction * clone(  ) const {
        bp::override func_clone = this->get_override( "clone" );
        return func_clone(  );
    }

    virtual double evaluate( ::kvector_t const & q ) const {
        bp::override func_evaluate = this->get_override( "evaluate" );
        return func_evaluate( boost::ref(q) );
    }

    virtual double getKappa(  ) const  {
        if( bp::override func_getKappa = this->get_override( "getKappa" ) )
            return func_getKappa(  );
        else{
            return this->IInterferenceFunction::getKappa(  );
        }
    }
    
    double default_getKappa(  ) const  {
        return IInterferenceFunction::getKappa( );
    }

    virtual double getParticleDensity(  ) const  {
        if( bp::override func_getParticleDensity = this->get_override( "getParticleDensity" ) )
            return func_getParticleDensity(  );
        else{
            return this->IInterferenceFunction::getParticleDensity(  );
        }
    }
    
    double default_getParticleDensity(  ) const  {
        return IInterferenceFunction::getParticleDensity( );
    }

    virtual ::ISample * cloneInvertB(  ) const  {
        if( bp::override func_cloneInvertB = this->get_override( "cloneInvertB" ) )
            return func_cloneInvertB(  );
        else{
            return this->ISample::cloneInvertB(  );
        }
    }
    
    ::ISample * default_cloneInvertB(  ) const  {
        return ISample::cloneInvertB( );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ISample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ISample::getChildren( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual ::std::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ISample::size(  );
        }
    }
    
    ::std::size_t default_size(  ) const  {
        return ISample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_IInterferenceFunction_class(){

    { //::IInterferenceFunction
        typedef bp::class_< IInterferenceFunction_wrapper, bp::bases< ISample >, std::auto_ptr< IInterferenceFunction_wrapper >, boost::noncopyable > IInterferenceFunction_exposer_t;
        IInterferenceFunction_exposer_t IInterferenceFunction_exposer = IInterferenceFunction_exposer_t( "IInterferenceFunction", "Interface to interference functions." );
        bp::scope IInterferenceFunction_scope( IInterferenceFunction_exposer );
        { //::IInterferenceFunction::clone
        
            typedef ::IInterferenceFunction * ( ::IInterferenceFunction::*clone_function_type)(  ) const;
            
            IInterferenceFunction_exposer.def( 
                "clone"
                , bp::pure_virtual( clone_function_type(&::IInterferenceFunction::clone) )
                , bp::return_value_policy< bp::manage_new_object >()
                , "Evaluates the interference function for a given wavevector transfer (only the real x and y components are relevant) " );
        
        }
        { //::IInterferenceFunction::evaluate
        
            typedef double ( ::IInterferenceFunction::*evaluate_function_type)( ::kvector_t const & ) const;
            
            IInterferenceFunction_exposer.def( 
                "evaluate"
                , bp::pure_virtual( evaluate_function_type(&::IInterferenceFunction::evaluate) )
                , ( bp::arg("q") )
                , "Evaluates the interference function for a given wavevector transfer (only the real x and y components are relevant) " );
        
        }
        { //::IInterferenceFunction::getKappa
        
            typedef double ( ::IInterferenceFunction::*getKappa_function_type)(  ) const;
            typedef double ( IInterferenceFunction_wrapper::*default_getKappa_function_type)(  ) const;
            
            IInterferenceFunction_exposer.def( 
                "getKappa"
                , getKappa_function_type(&::IInterferenceFunction::getKappa)
                , default_getKappa_function_type(&IInterferenceFunction_wrapper::default_getKappa) );
        
        }
        { //::IInterferenceFunction::getParticleDensity
        
            typedef double ( ::IInterferenceFunction::*getParticleDensity_function_type)(  ) const;
            typedef double ( IInterferenceFunction_wrapper::*default_getParticleDensity_function_type)(  ) const;
            
            IInterferenceFunction_exposer.def( 
                "getParticleDensity"
                , getParticleDensity_function_type(&::IInterferenceFunction::getParticleDensity)
                , default_getParticleDensity_function_type(&IInterferenceFunction_wrapper::default_getParticleDensity) );
        
        }
        { //::ISample::cloneInvertB
        
            typedef ::ISample * ( ::ISample::*cloneInvertB_function_type)(  ) const;
            typedef ::ISample * ( IInterferenceFunction_wrapper::*default_cloneInvertB_function_type)(  ) const;
            
            IInterferenceFunction_exposer.def( 
                "cloneInvertB"
                , cloneInvertB_function_type(&::ISample::cloneInvertB)
                , default_cloneInvertB_function_type(&IInterferenceFunction_wrapper::default_cloneInvertB)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( IInterferenceFunction_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            IInterferenceFunction_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&IInterferenceFunction_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ISample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ISample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( IInterferenceFunction_wrapper::*default_getChildren_function_type)(  ) const;
            
            IInterferenceFunction_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ISample::getChildren)
                , default_getChildren_function_type(&IInterferenceFunction_wrapper::default_getChildren) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( IInterferenceFunction_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            IInterferenceFunction_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&IInterferenceFunction_wrapper::default_printSampleTree) );
        
        }
        { //::ISample::size
        
            typedef ::std::size_t ( ::ISample::*size_function_type)(  ) const;
            typedef ::std::size_t ( IInterferenceFunction_wrapper::*default_size_function_type)(  ) const;
            
            IInterferenceFunction_exposer.def( 
                "size"
                , size_function_type(&::ISample::size)
                , default_size_function_type(&IInterferenceFunction_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( IInterferenceFunction_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            IInterferenceFunction_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&IInterferenceFunction_wrapper::default_transferToCPP) );
        
        }
    }

}
