// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "IRotation.pypp.h"

namespace bp = boost::python;

struct IRotation_wrapper : IRotation, bp::wrapper< IRotation > {

    IRotation_wrapper()
    : IRotation()
      , bp::wrapper< IRotation >(){
        // null constructor
        m_pyobj = 0;
    }

    virtual ::IRotation * clone(  ) const {
        bp::override func_clone = this->get_override( "clone" );
        return func_clone(  );
    }

    virtual ::IRotation * cloneInvertB(  ) const {
        bp::override func_cloneInvertB = this->get_override( "cloneInvertB" );
        return func_cloneInvertB(  );
    }

    virtual ::IRotation * createInverse(  ) const {
        bp::override func_createInverse = this->get_override( "createInverse" );
        return func_createInverse(  );
    }

    virtual ::Geometry::Transform3D getTransform3D(  ) const {
        bp::override func_getTransform3D = this->get_override( "getTransform3D" );
        return func_getTransform3D(  );
    }

    virtual bool isIdentity(  ) const  {
        if( bp::override func_isIdentity = this->get_override( "isIdentity" ) )
            return func_isIdentity(  );
        else{
            return this->IRotation::isIdentity(  );
        }
    }
    
    bool default_isIdentity(  ) const  {
        return IRotation::isIdentity( );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ISample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ISample::getChildren( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual ::std::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ISample::size(  );
        }
    }
    
    ::std::size_t default_size(  ) const  {
        return ISample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_IRotation_class(){

    { //::IRotation
        typedef bp::class_< IRotation_wrapper, bp::bases< ISample >, std::auto_ptr< IRotation_wrapper >, boost::noncopyable > IRotation_exposer_t;
        IRotation_exposer_t IRotation_exposer = IRotation_exposer_t( "IRotation", "An interface for classes representing a rotatio." );
        bp::scope IRotation_scope( IRotation_exposer );
        { //::IRotation::clone
        
            typedef ::IRotation * ( ::IRotation::*clone_function_type)(  ) const;
            
            IRotation_exposer.def( 
                "clone"
                , bp::pure_virtual( clone_function_type(&::IRotation::clone) )
                , bp::return_value_policy< bp::manage_new_object >()
                , "Returns a clone." );
        
        }
        { //::IRotation::cloneInvertB
        
            typedef ::IRotation * ( ::IRotation::*cloneInvertB_function_type)(  ) const;
            
            IRotation_exposer.def( 
                "cloneInvertB"
                , bp::pure_virtual( cloneInvertB_function_type(&::IRotation::cloneInvertB) )
                , bp::return_value_policy< bp::reference_existing_object >()
                , "Returns a clone with inverted magnetic fields." );
        
        }
        { //::IRotation::createInverse
        
            typedef ::IRotation * ( ::IRotation::*createInverse_function_type)(  ) const;
            
            IRotation_exposer.def( 
                "createInverse"
                , bp::pure_virtual( createInverse_function_type(&::IRotation::createInverse) )
                , bp::return_value_policy< bp::manage_new_object >()
                , "Returns a new IRotation object that is the current object's inverse." );
        
        }
        { //::IRotation::createRotation
        
            typedef ::IRotation * ( *createRotation_function_type )( ::Geometry::Transform3D const & );
            
            IRotation_exposer.def( 
                "createRotation"
                , createRotation_function_type( &::IRotation::createRotation )
                , ( bp::arg("transform") )
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::IRotation::getTransform3D
        
            typedef ::Geometry::Transform3D ( ::IRotation::*getTransform3D_function_type)(  ) const;
            
            IRotation_exposer.def( 
                "getTransform3D"
                , bp::pure_virtual( getTransform3D_function_type(&::IRotation::getTransform3D) )
                , "Returns transformation." );
        
        }
        { //::IRotation::isIdentity
        
            typedef bool ( ::IRotation::*isIdentity_function_type)(  ) const;
            typedef bool ( IRotation_wrapper::*default_isIdentity_function_type)(  ) const;
            
            IRotation_exposer.def( 
                "isIdentity"
                , isIdentity_function_type(&::IRotation::isIdentity)
                , default_isIdentity_function_type(&IRotation_wrapper::default_isIdentity) );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( IRotation_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            IRotation_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&IRotation_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ISample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ISample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( IRotation_wrapper::*default_getChildren_function_type)(  ) const;
            
            IRotation_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ISample::getChildren)
                , default_getChildren_function_type(&IRotation_wrapper::default_getChildren) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( IRotation_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            IRotation_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&IRotation_wrapper::default_printSampleTree) );
        
        }
        { //::ISample::size
        
            typedef ::std::size_t ( ::ISample::*size_function_type)(  ) const;
            typedef ::std::size_t ( IRotation_wrapper::*default_size_function_type)(  ) const;
            
            IRotation_exposer.def( 
                "size"
                , size_function_type(&::ISample::size)
                , default_size_function_type(&IRotation_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( IRotation_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            IRotation_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&IRotation_wrapper::default_transferToCPP) );
        
        }
        IRotation_exposer.staticmethod( "createRotation" );
    }

}
