// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "Layer.pypp.h"

namespace bp = boost::python;

struct Layer_wrapper : Layer, bp::wrapper< Layer > {

    Layer_wrapper( )
    : Layer( )
      , bp::wrapper< Layer >(){
        // null constructor
    m_pyobj = 0;
    }

    Layer_wrapper(::IMaterial const & material, double thickness=0 )
    : Layer( boost::ref(material), thickness )
      , bp::wrapper< Layer >(){
        // constructor
    m_pyobj = 0;
    }

    Layer_wrapper(::Layer const & other )
    : Layer( boost::ref(other) )
      , bp::wrapper< Layer >(){
        // copy constructor
    m_pyobj = 0;
    }

    virtual void addLayout( ::ILayout const & decoration ) {
        if( bp::override func_addLayout = this->get_override( "addLayout" ) )
            func_addLayout( boost::ref(decoration) );
        else{
            this->Layer::addLayout( boost::ref(decoration) );
        }
    }
    
    void default_addLayout( ::ILayout const & decoration ) {
        Layer::addLayout( boost::ref(decoration) );
    }

    virtual ::Layer * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->Layer::clone(  );
        }
    }
    
    ::Layer * default_clone(  ) const  {
        return Layer::clone( );
    }

    virtual ::Layer * cloneInvertB(  ) const  {
        if( bp::override func_cloneInvertB = this->get_override( "cloneInvertB" ) )
            return func_cloneInvertB(  );
        else{
            return this->Layer::cloneInvertB(  );
        }
    }
    
    ::Layer * default_cloneInvertB(  ) const  {
        return Layer::cloneInvertB( );
    }

    virtual ::ILayout const * getLayout( ::std::size_t i ) const  {
        if( bp::override func_getLayout = this->get_override( "getLayout" ) )
            return func_getLayout( i );
        else{
            return this->Layer::getLayout( i );
        }
    }
    
    ::ILayout const * default_getLayout( ::std::size_t i ) const  {
        return Layer::getLayout( i );
    }

    virtual ::IMaterial const * getMaterial(  ) const  {
        if( bp::override func_getMaterial = this->get_override( "getMaterial" ) )
            return func_getMaterial(  );
        else{
            return this->Layer::getMaterial(  );
        }
    }
    
    ::IMaterial const * default_getMaterial(  ) const  {
        return Layer::getMaterial( );
    }

    virtual ::complex_t getRefractiveIndex(  ) const  {
        if( bp::override func_getRefractiveIndex = this->get_override( "getRefractiveIndex" ) )
            return func_getRefractiveIndex(  );
        else{
            return this->Layer::getRefractiveIndex(  );
        }
    }
    
    ::complex_t default_getRefractiveIndex(  ) const  {
        return Layer::getRefractiveIndex( );
    }

    virtual double getThickness(  ) const  {
        if( bp::override func_getThickness = this->get_override( "getThickness" ) )
            return func_getThickness(  );
        else{
            return this->Layer::getThickness(  );
        }
    }
    
    double default_getThickness(  ) const  {
        return Layer::getThickness( );
    }

    virtual void setMaterial( ::IMaterial const & material ) {
        if( bp::override func_setMaterial = this->get_override( "setMaterial" ) )
            func_setMaterial( boost::ref(material) );
        else{
            this->Layer::setMaterial( boost::ref(material) );
        }
    }
    
    void default_setMaterial( ::IMaterial const & material ) {
        Layer::setMaterial( boost::ref(material) );
    }

    virtual void setMaterialAndThickness( ::IMaterial const & material, double thickness ) {
        if( bp::override func_setMaterialAndThickness = this->get_override( "setMaterialAndThickness" ) )
            func_setMaterialAndThickness( boost::ref(material), thickness );
        else{
            this->Layer::setMaterialAndThickness( boost::ref(material), thickness );
        }
    }
    
    void default_setMaterialAndThickness( ::IMaterial const & material, double thickness ) {
        Layer::setMaterialAndThickness( boost::ref(material), thickness );
    }

    virtual void setThickness( double thickness ) {
        if( bp::override func_setThickness = this->get_override( "setThickness" ) )
            func_setThickness( thickness );
        else{
            this->Layer::setThickness( thickness );
        }
    }
    
    void default_setThickness( double thickness ) {
        Layer::setThickness( thickness );
    }

    virtual bool containsMagneticMaterial(  ) const  {
        if( bp::override func_containsMagneticMaterial = this->get_override( "containsMagneticMaterial" ) )
            return func_containsMagneticMaterial(  );
        else{
            return this->ISample::containsMagneticMaterial(  );
        }
    }
    
    bool default_containsMagneticMaterial(  ) const  {
        return ISample::containsMagneticMaterial( );
    }

    virtual ::std::vector< const ISample* > getChildren(  ) const  {
        if( bp::override func_getChildren = this->get_override( "getChildren" ) )
            return func_getChildren(  );
        else{
            return this->ICompositeSample::getChildren(  );
        }
    }
    
    ::std::vector< const ISample* > default_getChildren(  ) const  {
        return ICompositeSample::getChildren( );
    }

    virtual void printSampleTree(  ) {
        if( bp::override func_printSampleTree = this->get_override( "printSampleTree" ) )
            func_printSampleTree(  );
        else{
            this->ISample::printSampleTree(  );
        }
    }
    
    void default_printSampleTree(  ) {
        ISample::printSampleTree( );
    }

    virtual ::std::size_t size(  ) const  {
        if( bp::override func_size = this->get_override( "size" ) )
            return func_size(  );
        else{
            return this->ICompositeSample::size(  );
        }
    }
    
    ::std::size_t default_size(  ) const  {
        return ICompositeSample::size( );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_Layer_class(){

    { //::Layer
        typedef bp::class_< Layer_wrapper, bp::bases< ICompositeSample >, std::auto_ptr< Layer_wrapper >, boost::noncopyable > Layer_exposer_t;
        Layer_exposer_t Layer_exposer = Layer_exposer_t( "Layer", "A layer with thickness and materia.", bp::init< >("Constructs empty layer.") );
        bp::scope Layer_scope( Layer_exposer );
        Layer_exposer.def( bp::init< IMaterial const &, bp::optional< double > >(( bp::arg("material"), bp::arg("thickness")=0 ), "Constructs layer made of _material_ with _thickness_ in nanometers and decoration.") );
        Layer_exposer.def( bp::init< Layer const & >(( bp::arg("other") )) );
        { //::Layer::addLayout
        
            typedef void ( ::Layer::*addLayout_function_type)( ::ILayout const & ) ;
            typedef void ( Layer_wrapper::*default_addLayout_function_type)( ::ILayout const & ) ;
            
            Layer_exposer.def( 
                "addLayout"
                , addLayout_function_type(&::Layer::addLayout)
                , default_addLayout_function_type(&Layer_wrapper::default_addLayout)
                , ( bp::arg("decoration") ) );
        
        }
        { //::Layer::clone
        
            typedef ::Layer * ( ::Layer::*clone_function_type)(  ) const;
            typedef ::Layer * ( Layer_wrapper::*default_clone_function_type)(  ) const;
            
            Layer_exposer.def( 
                "clone"
                , clone_function_type(&::Layer::clone)
                , default_clone_function_type(&Layer_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::Layer::cloneInvertB
        
            typedef ::Layer * ( ::Layer::*cloneInvertB_function_type)(  ) const;
            typedef ::Layer * ( Layer_wrapper::*default_cloneInvertB_function_type)(  ) const;
            
            Layer_exposer.def( 
                "cloneInvertB"
                , cloneInvertB_function_type(&::Layer::cloneInvertB)
                , default_cloneInvertB_function_type(&Layer_wrapper::default_cloneInvertB)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::Layer::createLayoutSimulation
        
            typedef ::LayerDWBASimulation * ( ::Layer::*createLayoutSimulation_function_type)( ::std::size_t ) const;
            
            Layer_exposer.def( 
                "createLayoutSimulation"
                , createLayoutSimulation_function_type( &::Layer::createLayoutSimulation )
                , ( bp::arg("layout_index") )
                , bp::return_value_policy< bp::manage_new_object >()
                , "creates and returns a LayerDWBASimulation for the given layout." );
        
        }
        { //::Layer::getLayout
        
            typedef ::ILayout const * ( ::Layer::*getLayout_function_type)( ::std::size_t ) const;
            typedef ::ILayout const * ( Layer_wrapper::*default_getLayout_function_type)( ::std::size_t ) const;
            
            Layer_exposer.def( 
                "getLayout"
                , getLayout_function_type(&::Layer::getLayout)
                , default_getLayout_function_type(&Layer_wrapper::default_getLayout)
                , ( bp::arg("i") )
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::Layer::getMaterial
        
            typedef ::IMaterial const * ( ::Layer::*getMaterial_function_type)(  ) const;
            typedef ::IMaterial const * ( Layer_wrapper::*default_getMaterial_function_type)(  ) const;
            
            Layer_exposer.def( 
                "getMaterial"
                , getMaterial_function_type(&::Layer::getMaterial)
                , default_getMaterial_function_type(&Layer_wrapper::default_getMaterial)
                , bp::return_value_policy< bp::reference_existing_object >() );
        
        }
        { //::Layer::getNumberOfLayers
        
            typedef ::std::size_t ( ::Layer::*getNumberOfLayers_function_type)(  ) const;
            
            Layer_exposer.def( 
                "getNumberOfLayers"
                , getNumberOfLayers_function_type( &::Layer::getNumberOfLayers ) );
        
        }
        { //::Layer::getNumberOfLayouts
        
            typedef ::std::size_t ( ::Layer::*getNumberOfLayouts_function_type)(  ) const;
            
            Layer_exposer.def( 
                "getNumberOfLayouts"
                , getNumberOfLayouts_function_type( &::Layer::getNumberOfLayouts ) );
        
        }
        { //::Layer::getRefractiveIndex
        
            typedef ::complex_t ( ::Layer::*getRefractiveIndex_function_type)(  ) const;
            typedef ::complex_t ( Layer_wrapper::*default_getRefractiveIndex_function_type)(  ) const;
            
            Layer_exposer.def( 
                "getRefractiveIndex"
                , getRefractiveIndex_function_type(&::Layer::getRefractiveIndex)
                , default_getRefractiveIndex_function_type(&Layer_wrapper::default_getRefractiveIndex) );
        
        }
        { //::Layer::getRefractiveIndex2
        
            typedef ::complex_t ( ::Layer::*getRefractiveIndex2_function_type)(  ) const;
            
            Layer_exposer.def( 
                "getRefractiveIndex2"
                , getRefractiveIndex2_function_type( &::Layer::getRefractiveIndex2 )
                , "Returns squared refractive index of the layer's material." );
        
        }
        { //::Layer::getThickness
        
            typedef double ( ::Layer::*getThickness_function_type)(  ) const;
            typedef double ( Layer_wrapper::*default_getThickness_function_type)(  ) const;
            
            Layer_exposer.def( 
                "getThickness"
                , getThickness_function_type(&::Layer::getThickness)
                , default_getThickness_function_type(&Layer_wrapper::default_getThickness) );
        
        }
        { //::Layer::getTotalAbundance
        
            typedef double ( ::Layer::*getTotalAbundance_function_type)(  ) const;
            
            Layer_exposer.def( 
                "getTotalAbundance"
                , getTotalAbundance_function_type( &::Layer::getTotalAbundance ) );
        
        }
        { //::Layer::getTotalParticleSurfaceDensity
        
            typedef double ( ::Layer::*getTotalParticleSurfaceDensity_function_type)( ::std::size_t ) const;
            
            Layer_exposer.def( 
                "getTotalParticleSurfaceDensity"
                , getTotalParticleSurfaceDensity_function_type( &::Layer::getTotalParticleSurfaceDensity )
                , ( bp::arg("layout_index") )
                , "creates and returns a LayerDWBASimulation for the given layout." );
        
        }
        { //::Layer::setMaterial
        
            typedef void ( ::Layer::*setMaterial_function_type)( ::IMaterial const & ) ;
            typedef void ( Layer_wrapper::*default_setMaterial_function_type)( ::IMaterial const & ) ;
            
            Layer_exposer.def( 
                "setMaterial"
                , setMaterial_function_type(&::Layer::setMaterial)
                , default_setMaterial_function_type(&Layer_wrapper::default_setMaterial)
                , ( bp::arg("material") ) );
        
        }
        { //::Layer::setMaterialAndThickness
        
            typedef void ( ::Layer::*setMaterialAndThickness_function_type)( ::IMaterial const &,double ) ;
            typedef void ( Layer_wrapper::*default_setMaterialAndThickness_function_type)( ::IMaterial const &,double ) ;
            
            Layer_exposer.def( 
                "setMaterialAndThickness"
                , setMaterialAndThickness_function_type(&::Layer::setMaterialAndThickness)
                , default_setMaterialAndThickness_function_type(&Layer_wrapper::default_setMaterialAndThickness)
                , ( bp::arg("material"), bp::arg("thickness") ) );
        
        }
        { //::Layer::setNumberOfLayers
        
            typedef void ( ::Layer::*setNumberOfLayers_function_type)( ::std::size_t ) ;
            
            Layer_exposer.def( 
                "setNumberOfLayers"
                , setNumberOfLayers_function_type( &::Layer::setNumberOfLayers )
                , ( bp::arg("n_layers") ) );
        
        }
        { //::Layer::setThickness
        
            typedef void ( ::Layer::*setThickness_function_type)( double ) ;
            typedef void ( Layer_wrapper::*default_setThickness_function_type)( double ) ;
            
            Layer_exposer.def( 
                "setThickness"
                , setThickness_function_type(&::Layer::setThickness)
                , default_setThickness_function_type(&Layer_wrapper::default_setThickness)
                , ( bp::arg("thickness") ) );
        
        }
        { //::ISample::containsMagneticMaterial
        
            typedef bool ( ::ISample::*containsMagneticMaterial_function_type)(  ) const;
            typedef bool ( Layer_wrapper::*default_containsMagneticMaterial_function_type)(  ) const;
            
            Layer_exposer.def( 
                "containsMagneticMaterial"
                , containsMagneticMaterial_function_type(&::ISample::containsMagneticMaterial)
                , default_containsMagneticMaterial_function_type(&Layer_wrapper::default_containsMagneticMaterial) );
        
        }
        { //::ICompositeSample::getChildren
        
            typedef ::std::vector< const ISample* > ( ::ICompositeSample::*getChildren_function_type)(  ) const;
            typedef ::std::vector< const ISample* > ( Layer_wrapper::*default_getChildren_function_type)(  ) const;
            
            Layer_exposer.def( 
                "getChildren"
                , getChildren_function_type(&::ICompositeSample::getChildren)
                , default_getChildren_function_type(&Layer_wrapper::default_getChildren) );
        
        }
        { //::ISample::printSampleTree
        
            typedef void ( ::ISample::*printSampleTree_function_type)(  ) ;
            typedef void ( Layer_wrapper::*default_printSampleTree_function_type)(  ) ;
            
            Layer_exposer.def( 
                "printSampleTree"
                , printSampleTree_function_type(&::ISample::printSampleTree)
                , default_printSampleTree_function_type(&Layer_wrapper::default_printSampleTree) );
        
        }
        { //::ICompositeSample::size
        
            typedef ::std::size_t ( ::ICompositeSample::*size_function_type)(  ) const;
            typedef ::std::size_t ( Layer_wrapper::*default_size_function_type)(  ) const;
            
            Layer_exposer.def( 
                "size"
                , size_function_type(&::ICompositeSample::size)
                , default_size_function_type(&Layer_wrapper::default_size) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( Layer_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            Layer_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&Layer_wrapper::default_transferToCPP) );
        
        }
    }

}
