// This file has been generated by Py++.

// ************************************************************************** //
//
//  BornAgain: simulate and fit scattering at grazing incidence
//
//! @file      Automatically generated boost::python code for BornAgain Python bindings
//! @brief     Automatically generated boost::python code for BornAgain Python bindings
//!
//! @homepage  http://bornagainproject.org
//! @license   GNU General Public License v3 or higher (see COPYING)
//! @copyright Forschungszentrum Juelich GmbH 2015
//! @authors   Scientific Computing Group at MLZ Garching
//! @authors   C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke
//
// ************************************************************************** //

#include "Macros.h"
GCC_DIAG_OFF(unused-parameter)
GCC_DIAG_OFF(missing-field-initializers)
#include "boost/python.hpp"
GCC_DIAG_ON(unused-parameter)
GCC_DIAG_ON(missing-field-initializers)
#include "PythonCoreList.h"
#include "Rectangle.pypp.h"

namespace bp = boost::python;

struct Rectangle_wrapper : Geometry::Rectangle, bp::wrapper< Geometry::Rectangle > {

    Rectangle_wrapper(double xlow, double ylow, double xup, double yup )
    : Geometry::Rectangle( xlow, ylow, xup, yup )
      , bp::wrapper< Geometry::Rectangle >(){
        // constructor
    m_pyobj = 0;
    }

    virtual ::Geometry::Rectangle * clone(  ) const  {
        if( bp::override func_clone = this->get_override( "clone" ) )
            return func_clone(  );
        else{
            return this->Geometry::Rectangle::clone(  );
        }
    }
    
    ::Geometry::Rectangle * default_clone(  ) const  {
        return Geometry::Rectangle::clone( );
    }

    virtual bool contains( double x, double y ) const  {
        if( bp::override func_contains = this->get_override( "contains" ) )
            return func_contains( x, y );
        else{
            return this->Geometry::Rectangle::contains( x, y );
        }
    }
    
    bool default_contains( double x, double y ) const  {
        return Geometry::Rectangle::contains( x, y );
    }

    virtual bool contains( ::Bin1D const & binx, ::Bin1D const & biny ) const  {
        if( bp::override func_contains = this->get_override( "contains" ) )
            return func_contains( boost::ref(binx), boost::ref(biny) );
        else{
            return this->Geometry::Rectangle::contains( boost::ref(binx), boost::ref(biny) );
        }
    }
    
    bool default_contains( ::Bin1D const & binx, ::Bin1D const & biny ) const  {
        return Geometry::Rectangle::contains( boost::ref(binx), boost::ref(biny) );
    }

    virtual void transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        if( bp::override func_transferToCPP = this->get_override( "transferToCPP" ) )
            func_transferToCPP(  );
        else{
            this->ICloneable::transferToCPP(  );
        }
    }
    
    void default_transferToCPP(  ) {
        
        if( !this->m_pyobj) {
            this->m_pyobj = boost::python::detail::wrapper_base_::get_owner(*this);
            Py_INCREF(this->m_pyobj);
        }
        
        ICloneable::transferToCPP( );
    }

    PyObject* m_pyobj;

};

void register_Rectangle_class(){

    { //::Geometry::Rectangle
        typedef bp::class_< Rectangle_wrapper, bp::bases< Geometry::IShape2D >, std::auto_ptr< Rectangle_wrapper >, boost::noncopyable > Rectangle_exposer_t;
        Rectangle_exposer_t Rectangle_exposer = Rectangle_exposer_t( "Rectangle", "The rectangle shape having its axis aligned to the coordinate system (non-rotated so far).", bp::init< double, double, double, double >(( bp::arg("xlow"), bp::arg("ylow"), bp::arg("xup"), bp::arg("yup") ), "Rectangle constructor with lower left and upper right coordinates @param xlow x-coordinate of lower left corner @param ylow y-coordinate of lower left corner @param xup x-coordinate of upper right corner @param yup y-coordinate of upper right corner \n\n:Parameters:\n  - 'xlow' - x-coordinate of lower left corner\n  - 'ylow' - y-coordinate of lower left corner\n  - 'xup' - x-coordinate of upper right corner\n  - 'yup' - y-coordinate of upper right corner\n") );
        bp::scope Rectangle_scope( Rectangle_exposer );
        { //::Geometry::Rectangle::clone
        
            typedef ::Geometry::Rectangle * ( ::Geometry::Rectangle::*clone_function_type)(  ) const;
            typedef ::Geometry::Rectangle * ( Rectangle_wrapper::*default_clone_function_type)(  ) const;
            
            Rectangle_exposer.def( 
                "clone"
                , clone_function_type(&::Geometry::Rectangle::clone)
                , default_clone_function_type(&Rectangle_wrapper::default_clone)
                , bp::return_value_policy< bp::manage_new_object >() );
        
        }
        { //::Geometry::Rectangle::contains
        
            typedef bool ( ::Geometry::Rectangle::*contains_function_type)( double,double ) const;
            typedef bool ( Rectangle_wrapper::*default_contains_function_type)( double,double ) const;
            
            Rectangle_exposer.def( 
                "contains"
                , contains_function_type(&::Geometry::Rectangle::contains)
                , default_contains_function_type(&Rectangle_wrapper::default_contains)
                , ( bp::arg("x"), bp::arg("y") ) );
        
        }
        { //::Geometry::Rectangle::contains
        
            typedef bool ( ::Geometry::Rectangle::*contains_function_type)( ::Bin1D const &,::Bin1D const & ) const;
            typedef bool ( Rectangle_wrapper::*default_contains_function_type)( ::Bin1D const &,::Bin1D const & ) const;
            
            Rectangle_exposer.def( 
                "contains"
                , contains_function_type(&::Geometry::Rectangle::contains)
                , default_contains_function_type(&Rectangle_wrapper::default_contains)
                , ( bp::arg("binx"), bp::arg("biny") ) );
        
        }
        { //::Geometry::Rectangle::getArea
        
            typedef double ( ::Geometry::Rectangle::*getArea_function_type)(  ) const;
            
            Rectangle_exposer.def( 
                "getArea"
                , getArea_function_type( &::Geometry::Rectangle::getArea )
                , "Returns true if mid point of two bins is inside rectangle." );
        
        }
        { //::Geometry::Rectangle::getXlow
        
            typedef double ( ::Geometry::Rectangle::*getXlow_function_type)(  ) const;
            
            Rectangle_exposer.def( 
                "getXlow"
                , getXlow_function_type( &::Geometry::Rectangle::getXlow ) );
        
        }
        { //::Geometry::Rectangle::getXup
        
            typedef double ( ::Geometry::Rectangle::*getXup_function_type)(  ) const;
            
            Rectangle_exposer.def( 
                "getXup"
                , getXup_function_type( &::Geometry::Rectangle::getXup ) );
        
        }
        { //::Geometry::Rectangle::getYlow
        
            typedef double ( ::Geometry::Rectangle::*getYlow_function_type)(  ) const;
            
            Rectangle_exposer.def( 
                "getYlow"
                , getYlow_function_type( &::Geometry::Rectangle::getYlow ) );
        
        }
        { //::Geometry::Rectangle::getYup
        
            typedef double ( ::Geometry::Rectangle::*getYup_function_type)(  ) const;
            
            Rectangle_exposer.def( 
                "getYup"
                , getYup_function_type( &::Geometry::Rectangle::getYup ) );
        
        }
        { //::ICloneable::transferToCPP
        
            typedef void ( ::ICloneable::*transferToCPP_function_type)(  ) ;
            typedef void ( Rectangle_wrapper::*default_transferToCPP_function_type)(  ) ;
            
            Rectangle_exposer.def( 
                "transferToCPP"
                , transferToCPP_function_type(&::ICloneable::transferToCPP)
                , default_transferToCPP_function_type(&Rectangle_wrapper::default_transferToCPP) );
        
        }
    }

}
